package com.ynet.life.sujrb.action;

import com.ynet.gene.core.Context;
import com.ynet.gene.core.GENEException;
import com.ynet.gene.data.IndexedCollection;
import com.ynet.gene.data.KeyedCollection;
import com.ynet.life.base.LifeAction;
import java.math.BigDecimal;
import java.util.Iterator;

public class SplitTransferDataAction extends LifeAction {

   private String tranAmt;
   private String splitIColl;


   public String execute(Context context) throws GENEException {
      String totalAmt = (String)context.getDataValue(this.tranAmt);
      BigDecimal count = new BigDecimal(totalAmt);
      String maxAmt = "50000.00";
      BigDecimal iColl = new BigDecimal(maxAmt);
      BigDecimal[] operArray = new BigDecimal[2];
      int var12;
      if(count.compareTo(iColl) == 1) {
         var12 = (operArray = count.divideAndRemainder(iColl))[0].intValue();
         ++var12;
      } else {
         var12 = 1;
      }

      IndexedCollection var13;
      KeyedCollection kColl = (KeyedCollection)(var13 = (IndexedCollection)context.get(this.splitIColl)).getDataElement().clone();

      for(int i = 0; i < var12; ++i) {
         KeyedCollection targetColl = new KeyedCollection();
         Iterator iterator = kColl.keySet().iterator();

         while(iterator.hasNext()) {
            String key = (String)iterator.next();
            if(context.containsKey(key)) {
               targetColl.addDataField(key, context.getDataValue(key));
            }
         }

         if(var12 == 1) {
            targetColl.setDataValue("payAmount", totalAmt);
         } else if(i == var12 - 1) {
            targetColl.setDataValue("payAmount", operArray[1].toString());
         } else {
            targetColl.setDataValue("payAmount", maxAmt);
         }

         var13.addDataElement(targetColl);
      }

      return "0";
   }

   public static void main(String[] payAmountBd) {
      String payAmountBd1 = "120903.98";
      BigDecimal payAmountBd2 = new BigDecimal(payAmountBd1);
      String maxAmountBd = "50000.00";
      BigDecimal maxAmountBd1 = new BigDecimal(maxAmountBd);
      BigDecimal[] operArray = new BigDecimal[2];
      if(payAmountBd2.compareTo(maxAmountBd1) == 1) {
         operArray = payAmountBd2.divideAndRemainder(maxAmountBd1);
      }

      System.out.println(operArray[0].toString());
      System.out.println(operArray[1].toString());
   }

   public String getTranAmt() {
      return this.tranAmt;
   }

   public void setTranAmt(String tranAmt) {
      this.tranAmt = tranAmt;
   }

   public String getSplitIColl() {
      return this.splitIColl;
   }

   public void setSplitIColl(String splitIColl) {
      this.splitIColl = splitIColl;
   }
}
